TNeoKernel: a real-time kernel
==============

TNeoKernel is a compact and fast real-time kernel for the embedded 32/16 bits
microprocessors. It performs a preemptive priority-based scheduling and a
round-robin scheduling for the tasks with identical priority.

TNeoKernel was born as a thorough review and re-implementation of [TNKernel](http://tnkernel.com) v2.7. The new kernel has well-formed code, inherited bugs are fixed as well as new features being added, it is well documented and tested carefully with unit-tests.

Currently it is available for PIC32 only, but will probably be ported to other architectures. Tested on PIC32MX.

Comprehensive documentation is available in two forms: html and pdf.

  * Latest stable TNeoKernel: [html](http://goo.gl/bwyAxZ), [pdf](http://goo.gl/d9W9HE)
  * Current development TNeoKernel BETA: [html](http://goo.gl/6S6Lv6), [pdf](http://goo.gl/c2Fp6e)
  * [Changelog](http://goo.gl/N9v65n)

Index of all available docs can be found [here](http://goo.gl/HJFOqe).

Documentation is generated by means of [doxygen](http://goo.gl/RQHRYr).

-----------------------------------------------------------------------------

This project was initially a fork of [PIC32 TNKernel
port](https://github.com/andersm/TNKernel-PIC32) by Anders Montonen. I don't
like several design decisions of original TNKernel, as well as **many** of the
implementation details, but Anders wants to keep his port as close to original
TNKernel as possible. So I decided to fork it and have fun implementing what I
want.

The more I get into how TNKernel works, the less I like its code. It appears as
a very hastily-written project: there is a lot of code duplication and a lot of
inconsistency, all of this leads to bugs. More, TNKernel is not documented well
enough and there are no unit tests for it, so I decided to reimplement it almost
completely. Refer to the page [Why reimplement TNKernel](http://dfrank.bitbucket.org/tneokernel_api/latest/html/why_reimplement.html) for details.

I decided not to care much about compatibility with original TNKernel API
because I really don't like several API decisions, so, I actually had to choose
new name for this project, in order to avoid confusion, hence "TNeoKernel".
Refer to the [Differences from TNKernel API](http://dfrank.bitbucket.org/tneokernel_api/latest/html/tnkernel_diff.html) page for details.

Together with almost totally re-writing TNKernel, I've implemented detailed
[unit tests](http://dfrank.bitbucket.org/tneokernel_api/latest/html/unit_tests.html) for it, to make sure I didn't break anything, and of course I've found several bugs in original TNKernel 2.7: refer to the section [Bugs of TNKernel 2.7](http://dfrank.bitbucket.org/tneokernel_api/latest/html/why_reimplement.html#why_reimplement__bugs). Unit tests are, or course, a "must-have" for the project like this; it's so strange bug original TNKernel seems untested.

Note that PIC32-dependent routines (such as context switch and so on) are
originally implemented by Anders Montonen; I examined them in detail and
changed several things which I believe should be implemented differently.
Anders, great thanks for sharing your job.

Another existing PIC32 port, [the one by Alex
Borisov](http://www.tnkernel.com/tn_port_pic24_dsPIC_PIC32.html), also affected
my project a bit. In fact, I used to use Alex's port for a long time, but it
has several concepts that I don't like, so I had to move eventually.
Nevertheless, Alex's port has several nice ideas and solutions, so I didn't
hesitate to take what I like from his port. Alex, thank you too.

And, of course, great thanks to the author of original TNKernel, Yuri Tiomkin.
Although the implementation of TNKernel is far from perfect in my opinion, the
ideas behind the implementation are generally really nice (that's why I decided
to reimplement it instead of starting from scratch), and it was great entry
point to the real-time kernels for me.

I would also like to thank my chiefs in the [ORION](http://orionspb.ru/)
company, Alexey Morozov and Alexey Gromov, for being flexible about my time.

For comprehensive information, refer to the documentation (see links at the top of this page)

